import "./cljs_env.js";
goog.provide('longdown.cli');
longdown.cli.cli_options = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-d","--out-dir DIR","Output directory"], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-h","--help"], null)], null);
longdown.cli.usage = (function longdown$cli$usage(options_summary){
return clojure.string.join.cljs$core$IFn$_invoke$arity$2("\n",new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, ["Convert longform markdown files to outline format used by Logseq","","Usage: longdown [options] file.md...","","Options:",options_summary], null));
});
longdown.cli.convert_files = (function longdown$cli$convert_files(out_dir,filenames){
var seq__21840 = cljs.core.seq(filenames);
var chunk__21841 = null;
var count__21842 = (0);
var i__21843 = (0);
while(true){
if((i__21843 < count__21842)){
var in_path = chunk__21841.cljs$core$IIndexed$_nth$arity$2(null,i__21843);
var out_path_21892 = shadow.esm.esm_import$node_path.join(out_dir,in_path);
shadow.esm.esm_import$node_fs.mkdirSync(shadow.esm.esm_import$node_path.dirname(out_path_21892),({"recursive": true}));

longdown.lib.spit(out_path_21892,longdown.lib.longform__GT_outline(longdown.lib.slurp(in_path)));


var G__21893 = seq__21840;
var G__21894 = chunk__21841;
var G__21895 = count__21842;
var G__21896 = (i__21843 + (1));
seq__21840 = G__21893;
chunk__21841 = G__21894;
count__21842 = G__21895;
i__21843 = G__21896;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__21840);
if(temp__5804__auto__){
var seq__21840__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__21840__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__21840__$1);
var G__21898 = cljs.core.chunk_rest(seq__21840__$1);
var G__21899 = c__5568__auto__;
var G__21900 = cljs.core.count(c__5568__auto__);
var G__21901 = (0);
seq__21840 = G__21898;
chunk__21841 = G__21899;
count__21842 = G__21900;
i__21843 = G__21901;
continue;
} else {
var in_path = cljs.core.first(seq__21840__$1);
var out_path_21904 = shadow.esm.esm_import$node_path.join(out_dir,in_path);
shadow.esm.esm_import$node_fs.mkdirSync(shadow.esm.esm_import$node_path.dirname(out_path_21904),({"recursive": true}));

longdown.lib.spit(out_path_21904,longdown.lib.longform__GT_outline(longdown.lib.slurp(in_path)));


var G__21905 = cljs.core.next(seq__21840__$1);
var G__21906 = null;
var G__21907 = (0);
var G__21908 = (0);
seq__21840 = G__21905;
chunk__21841 = G__21906;
count__21842 = G__21907;
i__21843 = G__21908;
continue;
}
} else {
return null;
}
}
break;
}
});
longdown.cli._main = (function longdown$cli$_main(var_args){
var args__5775__auto__ = [];
var len__5769__auto___21909 = arguments.length;
var i__5770__auto___21910 = (0);
while(true){
if((i__5770__auto___21910 < len__5769__auto___21909)){
args__5775__auto__.push((arguments[i__5770__auto___21910]));

var G__21911 = (i__5770__auto___21910 + (1));
i__5770__auto___21910 = G__21911;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return longdown.cli._main.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(longdown.cli._main.cljs$core$IFn$_invoke$arity$variadic = (function (args){
var map__21875 = clojure.tools.cli.parse_opts(args,longdown.cli.cli_options);
var map__21875__$1 = cljs.core.__destructure_map(map__21875);
var options = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21875__$1,new cljs.core.Keyword(null,"options","options",99638489));
var arguments$ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21875__$1,new cljs.core.Keyword(null,"arguments","arguments",-1182834456));
var summary = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21875__$1,new cljs.core.Keyword(null,"summary","summary",380847952));
var map__21876 = options;
var map__21876__$1 = cljs.core.__destructure_map(map__21876);
var out_dir = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21876__$1,new cljs.core.Keyword(null,"out-dir","out-dir",-939021234));
if(cljs.core.truth_((function (){var or__5045__auto__ = new cljs.core.Keyword(null,"help","help",-439233446).cljs$core$IFn$_invoke$arity$1(options);
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return cljs.core.empty_QMARK_(arguments$);
}
})())){
return cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([longdown.cli.usage(summary)], 0));
} else {
if((out_dir == null)){
cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Output directory is required"], 0));

return process.exit((1));
} else {
return longdown.cli.convert_files(out_dir,arguments$);

}
}
}));

(longdown.cli._main.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(longdown.cli._main.cljs$lang$applyTo = (function (seq21869){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq21869));
}));


//# sourceMappingURL=longdown.cli.js.map
